/*
 * DON'T EDIT cmds.h - Make changes in cmds.hh.
 *
 * Copyright (c) 1986, 2006 by The Trustees of Columbia University in
 * the City of New York.  Permission is granted to any individual or
 * institution to use, copy, or redistribute this software so long as it
 * is not sold for profit, provided this copyright notice is retained.
 */

/*
 * cmds.h - indices into the command dispatch table
 *
 * The value of the symbols below must correspond to the offset of
 * the corresponding command in the cmd_fn[] array!
 */

/*
 * These are also indices into the help string index.  Help topics
 * which are not commands should be #def'd at the end BEFORE NUMTOPICS
 */

#define CMD_ALIAS        0               /* */
#define CMD_ANSWER       1               /* */
#define CMD_BACKTRACK    2               /* */
#define CMD_BCC          3               /* */
#define CMD_BLANK        4               /* */
#define CMD_BROWSE       5               /* */
#define CMD_BUG          6               /* */
#define CMD_CC           7               /* */
#define CMD_CD           8               /* */
#define CMD_CHECK        9               /* */
#define CMD_CONTENT_TYPE 10              /* */
#define CMD_CONTINUE     11              /* */
#define CMD_COPY         12              /* */
#define CMD_COUNT        13              /* */
#define CMD_CREATE_INIT  14              /* */
#define CMD_DAYTIME      15              /* */
#define CMD_DEBUG        16              /* */
#define CMD_MEMDEBUG     17              /* */
#define CMD_DEFINE       18              /* */
#define CMD_DELETE       19              /* */
#define CMD_DISPLAY      20              /* */
#define CMD_DOWNLOAD     21              /* */
#define CMD_ECHO         22              /* */
#define CMD_EDIT         23              /* */
#define CMD_ERASE        24              /* */
#define CMD_EXAMINE      25              /* */
#define CMD_EXIT         26              /* */
#define CMD_EXPUNGE      27              /* */
#define CMD_FCC          28              /* */
#define CMD_FINGER       29              /* */
#define CMD_FLAG         30              /* */
#define CMD_FOLLOW       31              /* */
#define CMD_FORWARD      32              /* */
#define CMD_FROM         33              /* */
#define CMD_GET          34              /* */
#define CMD_HEADERS      35              /* */
#define CMD_HELP         36              /* */
#define CMD_INSERT       37              /* */
#define CMD_IN_REPLY_TO  38              /* */
#define CMD_JUMP         39              /* */
#define CMD_KEYWORD      40              /* */
#define CMD_KILL         41              /* */
#define CMD_LIST         42              /* */
#define CMD_LITERAL      43              /* */
#define CMD_MARK         44              /* */
#define CMD_MIME_VERSION 45              /* */
#define CMD_MOVE         46              /* */
#define CMD_NEXT         47              /* */
#define CMD_PREVIOUS     48              /* */
#define CMD_PRINT        49              /* */
#define CMD_PROFILE      50              /* */
#define CMD_PUSH         51              /* */
#define CMD_PWD          52              /* */
#define CMD_QD           53              /* */
#define CMD_QUIT         54              /* */
#define CMD_QQUIT        55              /* */
#define CMD_READ         56              /* */
#define CMD_REMAIL       57              /* */
#define CMD_REMOVE       58              /* */
#define CMD_REPLY        59              /* */
#define CMD_REPLY_TO     60              /* */
#define CMD_RESTORE_DRAFT 61             /* */
#define CMD_REVIEW       62              /* */
#define CMD_ROUTE        63              /* */
#define CMD_SAVE_DRAFT   64              /* */
#define CMD_SEND         65              /* */
#define CMD_SET          66              /* */
#define CMD_SHOW         67              /* */
#define CMD_SMAIL        68              /* */
#define CMD_SORT         69              /* */
#define CMD_SPELL        70              /* */
#define CMD_STATUS       71              /* */
#define CMD_SUBJECT      72              /* */
#define CMD_SUSPEND      73              /* */
#define CMD_TAKE         74              /* */
#define CMD_TEXT         75              /* */
#define CMD_TO           76              /* */
#define CMD_TRANSFER_ENCODING 77         /* */
#define CMD_TYPE         78              /* */
#define CMD_UNANSWER     79              /* */
#define CMD_UNDELETE     80              /* */
#define CMD_UNFLAG       81              /* */
#define CMD_UNKEYWORD    82              /* */
#define CMD_UNMARK       83              /* */
#define CMD_USER_HEADER  84              /* */
#define CMD_VERSION      85              /* */
#define CMD_WHO          86              /* */
#define CMD_WRITE        87              /* */
#define CMD_Z            88              /* */

#define CMD_HEADER       89              /* */
#define CMD_EXPAND       90              /* */

#define CMD_SENDER       91              /* */
#define CMD_ALL          92              /* */

#define CMD_INCLUDE      93              /* */
#define CMD_NOINCLUDE    94              /* */

#define HLP_CCMD         95              /* */
#define HLP_MESSAGE_SEQUENCE 96          /* */
#define HLP_MMINIT       97              /* */
#define HLP_MM           98              /* */
#define HLP_SHELL        99              /* */

#define HLP_TYPE_BABYL   100             /* */
#define HLP_TYPE_START HLP_TYPE_BABYL
#define HLP_TYPE_MBOX    101             /* */
#define HLP_TYPE_MH      102             /* */
#define HLP_TYPE_MTXT    103             /* */
#define HLP_TYPE_POP2    104             /* */
#define HLP_TYPE_POP3    105             /* */

#define NUMTOPICS        106             /* */
