#ifndef CONFIG_H_
#define CONFIG_H_
/*
 * Copyright (c) 1986, 2006 by The Trustees of Columbia University in
 * the City of New York.  Permission is granted to any individual or
 * institution to use, copy, or redistribute this software so long as it
 * is not sold for profit, provided this copyright notice is retained.
 */

/*
 * Configuration file for us
 */

#define BUGSTO "bug-mm"

#ifdef S_FILE
#include S_FILE
#else
#include "s-sun50.h"
#endif

/*
 *  Let's let sendmail do it's thing with From:, To:, Sender: headers.
 */

#define DONT_EMIT_FROM_HEADERS

#ifdef COLUMBIA
/* From here down is the Columbia University configuration */

/* If DONT_EMIT_FROM_HEADERS is defined REMAIL doesn't work right */
/* See display.c */
#ifdef DONT_EMIT_FROM_HEADERS
#undef DONT_EMIT_FROM_HEADERS
#endif	/* DONT_EMIT_FROM_HEADERS */

#define FORWARD_FILE ".forward"		/* .forward file name if used */
#define GNUEMACS "emacs"		/* name of GNU Emacs if present */
#undef HAVE_YP				/* use yp? */
#define HAVE_NFS			/* NFS used for some mail files? */
#undef HAVE_QUOTAS			/* have and use quota support? */

#ifndef HAVE_F_SETLK			/* We need file locking via fcntl() */
#define HAVE_F_SETLK
#endif /* HAVE_F_SETLK */
#undef HAVE_LOCKF
#undef HAVE_FLOCK

#ifndef LIBDIR
#define LIBDIR		"/opt/ACISmm/lib/"
#endif
#ifndef SYSINIT
#define SYSINIT		"/opt/ACISmm/lib/mm.conf"
#endif
#ifndef HELPFILE
#define HELPFILE	"/opt/ACISmm/lib/mm.help"
#endif
#ifndef HELPDIR
#define HELPDIR		"/opt/ACISmm/lib/help"
#endif
#ifndef MMAIL_PATH
#define MMAIL_PATH	"/opt/ACISmm/lib/mmail.el"
#endif
#ifndef MOVEMAIL
#define MOVEMAIL	"/opt/ACISmm/lib/movemail"
#endif
#endif /* COLUMBIA */

#endif /* CONFIG_H_ */
